#include <ogg/ogg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "speex_header.h"

int main(int argc,char *argv[]) {
	//ogg stuff
	int page_nb_packets;
	ogg_sync_state oy;
	ogg_page       og;
	ogg_packet     op;
	ogg_stream_state os;
	char *data;
	SpeexHeader *spxhead;
	FILE *input;
	size_t rcount;
	int off_count;
	if(argc!=2) {
		fprintf(stderr,"Wrong number of arguments. %s speex.spx\n",argv[0]);
		exit(1);
	}
	input=fopen(argv[1],"rb");
	if(!input) {
		perror("File open failed");
		exit(2);
	}
	ogg_sync_init(&oy);
	data = ogg_sync_buffer(&oy, 200);
	rcount = fread(data, sizeof(char), 200, input);
	ogg_sync_wrote(&oy, rcount);
	ogg_sync_pageout(&oy, &og);
	ogg_stream_init(&os, ogg_page_serialno(&og));
	ogg_stream_pagein(&os, &og); //fixme check for ==1
	ogg_stream_packetout(&os, &op); //fixme check for ==1
	/*
	rcount=fread(&spxhead,sizeof(spxhead),1,input);
	if(rcount!=1) {
		fprintf(stderr,"File error: short read: %i!= %i",rcount,sizeof(spxhead));
		exit(3) ;
	}
	*/
	spxhead=(SpeexHeader*)op.packet;
	printf("speex header\n");
	if(strncmp("Speex   ",spxhead->speex_string,8)) {
		fprintf(stderr,"Not a speex file!");
		exit(4);
	}
	printf("Version:%s\n",spxhead->speex_version);
	printf("rate:%i\n",spxhead->rate);
	printf("mode:%i\n",spxhead->mode);
	printf("mode_bitstream_version:%i\n",spxhead->mode_bitstream_version);
	printf("nb_channels:%i\n",spxhead->nb_channels);
	printf("bitrate:%i\n",spxhead->bitrate);
	printf("frame_size:%i\n",spxhead->frame_size);
	printf("vbr:%i\n",spxhead->vbr);
	printf("frames_per_packet:%i\n",spxhead->frames_per_packet);
	printf("extra_headers:%i\n",spxhead->extra_headers);
	do {
		while(ogg_sync_pageout(&oy, &og)==1) {
			ogg_stream_pagein(&os,&og);
			while((ogg_stream_packetout(&os,&op)==1)) {
				printf("Framesize:%i\n",op.bytes);
				for(off_count=0;off_count<op.bytes;off_count++) {
					printf("%d\n",*(op.packet+off_count));
				}
			}
		}
		data = ogg_sync_buffer(&oy, 200);
		rcount = fread(data, sizeof(char), 200, input);
		ogg_sync_wrote(&oy, rcount);
	}
	while(rcount);
}

